
#include "AudioTrackProcessor.h"
#include "AudioFileProcessor.h"

AudioTrackProcessor::AudioTrackProcessor() {
    setChannelLayoutOfBus(true, 0, AudioChannelSet::canonicalChannelSet(2));
    setChannelLayoutOfBus(false, 0, AudioChannelSet::canonicalChannelSet(2));
    audio_input_node_  = addNode(std::make_unique<AudioGraphIOProcessor>(AudioGraphIOProcessor::audioInputNode));
    audio_output_node_ = addNode(std::make_unique<AudioGraphIOProcessor>(AudioGraphIOProcessor::audioOutputNode));

    plugin_node_ = addNode(std::unique_ptr<AudioProcessor>(new AudioFileProcessor()));

    ConnectAudioNodes();
}

AudioTrackProcessor::~AudioTrackProcessor() {}

void AudioTrackProcessor::ConnectAudioNodes() {
	for (int channel(0); channel < 2; ++channel) {
		addConnection({ {audio_input_node_->nodeID, channel}, {plugin_node_->nodeID, channel} });
		addConnection({ {plugin_node_->nodeID, channel}, {audio_output_node_->nodeID, channel} });
	}
}
