
#pragma once
#include "JuceHeader.h"

class HostAudioPlayHead : public AudioPlayHead {
   public:
    HostAudioPlayHead(double sampling_rate);
    ~HostAudioPlayHead() {}

    bool getCurrentPosition(CurrentPositionInfo& result) override;

    void transportPlay(bool shouldStartPlaying) override;

    juce::int64 GetTimeInSamples() const;
    double GetTimeInSeconds() const;
    void SetTimeInSamples(juce::int64 new_value);
    void MoveTimeInSamples(juce::int64 delta);

    bool IsPlaying() const;

    void ChangeSamplingRate(double new_sampling_rate);

   private:
    juce::int64 time_in_samples_;
    bool is_playing_;
    double sampling_rate_;

    CriticalSection cs_;
};